/**
 * This work was created by participants in the DataONE project, and is
 * jointly copyrighted by participating institutions in DataONE. For 
 * more information on DataONE, see our web site at http://dataone.org.
 *
 *   Copyright ${year}
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 * 
 * $Id$
 */

package gov.ornl.mercury3.dwr_utils;

import java.util.Properties;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

/**
 * Keyword list utility.
 *
 */
public class SpatialList{

	private String[] docUSA;
	private String[] docWorld;
	private  Properties properties = null;
	

	public SpatialList() {
		try {
			ApplicationContext factory = new ClassPathXmlApplicationContext(
					"gov/ornl/mercury3/services/applicationContext.xml");
			properties = (Properties) factory.getBean("spatialList");
		} catch (Exception ex1) {
			ex1.printStackTrace();
		}
	}

	public String[] getSpatialList(String keyword1) {
		String dataList = properties.getProperty(keyword1).replaceAll("\"", "");
		String[] dataArray = dataList.split(",");
		return dataArray;
	}

	
}

    


